﻿var commonHandler = {
    token: "40f4cdda-ccc6-4232-a815-92fd7ac95f1f",
    sessionKey: "guideBlocksSessionKey",
    sessionPageCountKey: "guideBlocksSessionPageCountKey",
    cookieKey: "guideBlocks_anonymousId",
    projectIdentifier: null,
    versionIdentifier: null,
    filter: {
        userId: "",
        groupId: "",
        roleId: "",
        isAnonymous: false,
        sessionId: "",
        resourceTitle: "",
        webUserAgent: "",
        webSessionPageViews: 0,
        deviceType: 2,
        operatingSystem: "",
        language: ""
    },

    init: function () {
        var userId = "";
        var groupId = "";
        var roleId = "";

        commonHandler.startNewSession();

        if (userId)
            commonHandler.filter.userId = userId;


        if (groupId)
            commonHandler.filter.groupId = groupId;


        if (roleId)
            commonHandler.filter.roleId = roleId;


        commonHandler.initFilterDefaultValues();

        var identifier = commonHandler.getPageIdentifier();
        commonHandler.createOrUpdateCookie(this.cookieKey, commonHandler.generateUUID());

        commonHandler.projectIdentifier = this.token;
        commonHandler.token = this.token;

        commonHandler.initAutocomplete();
        commonHandler.attachHelpBeaconFrameEvents();
        commonHandler.attachEvents();
        commonHandler.setLinkUtm();


        $("#logo").attr("src", logoUrl);
        $("#logo").show();
        if (pageType === "h")
            $(".main-search-image").css("background-image", "url('" + backgroundUrl + "')");


        if (pageType === "s" || pageType === "t")
            commonHandler.logActivity("PHPL", { ActionGuid: topicId });
        else
            commonHandler.logActivity("PHPL", null);

        if (isExportMenuVisible === "true")
            $(".export-menu-container").show();

        this.displayWarning();
    },

    attachEvents: function () {
        $("#exportPdf").on("click", function () {
            commonHandler.exportPdf();
        });

        $("#btnDownloadPdf").on("click", function () {

        });
    },

    exportPdf: function () {
        $(".spinner-pdf").css({ "visibility": "visible" });
        $("#btnDownloadPdf").attr("disabled", true);
        $(".spinner-pdf").show();
        $("#PdfExportModal").modal("show");
        commonHandler.createPdf();
    },

    createPdf: function () {
        var data = {
            OnboardingToken: commonHandler.token,
            ProjectIdentifier: commonHandler.projectIdentifier,
            TopicId: topicId
        };

        $.ajax({
            type: 'POST',
            url: 'https://guideblocks.com/api/Onboarding/ExportPdf',
            data: data
        }).done(function (data) {
            $(".spinner-pdf").css({ "visibility": "hidden" });
            $("#btnDownloadPdf").attr("href", data);
            $("#btnDownloadPdf").attr("disabled", false);
        }).fail(function (errorHandler) {
            // TODO: error handling
            console.trace(errorHandler);
        });
    },

    initFilterDefaultValues: function () {
        if (this.filter.userId !== null && this.filter.userId !== "")
            this.filter.isAnonymous = false;
        else
            this.filter.isAnonymous = true;


        var isMobile = {
            Android: function () {
                return navigator.userAgent.match(/Android/i);
            },
            BlackBerry: function () {
                return navigator.userAgent.match(/BlackBerry/i);
            },
            iOS: function () {
                return navigator.userAgent.match(/iPhone|iPad|iPod/i);
            },
            Opera: function () {
                return navigator.userAgent.match(/Opera Mini/i);
            },
            Windows: function () {
                return navigator.userAgent.match(/IEMobile/i);
            },
            any: function () {
                return (isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows());
            }
        };

        this.filter.sessionId = this.getSessionId();
        this.filter.resourceTitle = $(document).find("title").text();
        this.filter.webUserAgent = navigator.userAgent;
        this.filter.deviceType = isMobile.any() !== null ? 1 : 0;
        this.filter.operatingSystem = navigator.platform;
        this.filter.language = navigator.language || navigator.userLanguage;
        this.filter.webSessionPageViews = sessionStorage.getItem(this.sessionPageCountKey);
    },

    createCookie: function (name, value, days) {
        var expires;
        if (days) {
            var date = new Date();
            date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
            expires = "; expires=" + date.toGMTString();
        }
        else {
            expires = "";
        }
        document.cookie = name + "=" + value + expires + "; path=/";
    },

    generateUUID: function () {
        var d = new Date().getTime();
        if (typeof performance !== 'undefined' && typeof performance.now === 'function') {
            d += performance.now(); //use high-precision timer if available
        }
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = (d + Math.random() * 16) % 16 | 0;
            d = Math.floor(d / 16);
            return (c === 'x' ? r : (r & 0x3 | 0x8)).toString(16);
        });
    },

    startNewSession: function () {
        if (!this.getSessionId())
            sessionStorage.setItem(this.sessionKey, this.getNewGuid());

        var iCount = 0;
        if (sessionStorage.getItem(this.sessionPageCountKey))
            iCount = sessionStorage.getItem(this.sessionPageCountKey);

        iCount++;
        sessionStorage.setItem(this.sessionPageCountKey, iCount);
    },

    getSessionId: function () {
        return sessionStorage.getItem(this.sessionKey);
    },

    getNewGuid: function () {
        function s4() {
            return Math.floor((1 + Math.random()) * 0x10000)
                .toString(16)
                .substring(1);
        }
        return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
            s4() + '-' + s4() + s4() + s4();
    },

    createOrUpdateCookie: function (cookieKey, value) {
        var cookie = this.getCookie(cookieKey);
        if (!cookie)
            this.createCookie(cookieKey, value, 180);
        else
            this.createCookie(cookieKey, cookie, 180);
    },

    getPageIdentifier: function () {
        return document.location.pathname;
    },

    getCookie: function (name) {
        if (document.cookie.length > 0) {
            c_start = document.cookie.indexOf(name + "=");
            if (c_start !== -1) {
                c_start = c_start + name.length + 1;
                c_end = document.cookie.indexOf(";", c_start);
                if (c_end === -1) {
                    c_end = document.cookie.length;
                }
                return unescape(document.cookie.substring(c_start, c_end));
            }
        }
        return "";
    },

    logActivity: function (activityType, activityDetails) {
        var data = {
            OnboardingToken: commonHandler.token,
            ProjectIdentifier: commonHandler.projectIdentifier,
            VersionIdentifier: commonHandler.versionIdentifier,
            ResourceIdentifier: commonHandler.identifierHash,
            ResourceUrl: commonHandler.getPageIdentifier(),
            UserId: commonHandler.filter.userId,
            GroupId: commonHandler.filter.groupId,
            RoleId: commonHandler.filter.roleId,
            IsAnonymous: commonHandler.filter.isAnonymous,
            SessionId: commonHandler.filter.sessionId,
            ResourceTitle: commonHandler.filter.resourceTitle,
            WebUserAgent: commonHandler.filter.webUserAgent,
            WebSessionPageViews: commonHandler.filter.webSessionPageViews,
            DeviceType: commonHandler.filter.deviceType,
            OperatingSystem: commonHandler.filter.operatingSystem,
            Language: commonHandler.filter.language,
            ActivityType: activityType,
            ActivityDetails: activityDetails,
            AnonymousId: this.getCookie(this.cookieKey)
        };
        //console.trace(data);
        $.ajax({
            type: 'POST',
            url: 'https://guideblocks.com/api/Onboarding/LogActivity',
            data: data
        }).done(function () {
        }).fail(function (errorHandler) {
            // TODO: error handling
            console.trace(errorHandler);
        });
    },

    initAutocomplete: function () {
        var $search = $(".typeahead");

        var results = new Bloodhound({
            datumTokenizer: Bloodhound.tokenizers.whitespace,
            queryTokenizer: Bloodhound.tokenizers.whitespace,
            remote: {
                url: 'https://guideblocks.com/api/SearchPublic/Suggest',
                prepare: function (query, settings) {
                    var txt = query;
                    var data = {
                        OnboardingToken: commonHandler.token,
                        ProjectIdentifier: commonHandler.projectIdentifier,
                        VersionIdentifier: commonHandler.versionIdentifier,
                        Query: txt
                    };

                    settings.type = "POST";
                    settings.contentType = "application/json; charset=UTF-8";
                    settings.data = JSON.stringify(data);

                    return settings;
                }
            }
        });

        results.initialize();

        $search.typeahead(null, {
            display: 'Title',
            source: results,
            limit: 10,
            hint: true,
            highlight: true,
            minLength: 1
        }).on('typeahead:selected', function (event, selection) {
            commonHandler.helpBeaconStartSearch(selection.Title, true, function (results) {
                commonHandler.handleSearch(results);
            });
        });
    },

    attachHelpBeaconFrameEvents: function () {
        $('body').on('keyup', 'input', function (e) {
            if (e.keyCode === 13 && $(this).val()) {
                commonHandler.helpBeaconStartSearch($(this).val(), true, function (results) {
                    commonHandler.handleSearch(results);
                });
            }

            //if (!$(this).val())
            //    $(".search-results-list").empty();
        });
    },

    handleSearch: function (results) {
        sessionStorage.setItem("documentariumSearchResults", JSON.stringify(results));

        setTimeout(function () {
            if (pageType === "t")
                window.location.href = "../SearchResults.html";
            else
                window.location.href = "SearchResults.html";
        }, 200);
    },

    helpBeaconStartSearch: function (searchText, doLog, callback) {
        if (doLog)
            this.logActivity("PHS", { StringValue: searchText });

        var query = '"' + searchText + '"';
        var action = {
            OnboardingToken: commonHandler.token,
            ProjectIdentifier: commonHandler.projectIdentifier,
            VersionIdentifier: commonHandler.versionIdentifier,
            Query: query
        };


        $.ajax(
            {
                cache: false,
                type: "POST",
                url: "https://guideblocks.com/api/SearchPublic/Search",
                data: JSON.stringify(action),
                contentType: "application/json; charset=utf-8",
                dataType: "json"
            })
            .success(function (results) {
                callback(results);
            });
    },

    getStoryTopicSiblings: function (data, parentId) {
        var res = [];

        $.each(data, function (i, item) {
            if (item.parent === parentId)
                res.push(item);
        });


        res.sort(function (a, b) {
            return a.displayOrder - b.displayOrder;
        });

        return res;
    },

    getStoryTopic: function (data, id) {
        var res = null;

        $.each(data, function (i, item) {
            if (item.id === id) {
                res = item;
                return false;
            }
        });

        return res;
    },

    getStoryTopicChilds: function (data, id) {
        var res = [];

        $.each(data, function (i, item) {
            if (item.parent === id)
                res.push(item);
        });


        res.sort(function (a, b) {
            return a.displayOrder - b.displayOrder;
        });

        return res;
    },

    loadBreadcrumb: function (data, currentId) {
        var $ol = $(".breadcrumb");

        $ol.empty();
        var current = this.getStoryTopic(data, currentId);
        if (current.parent !== "#") {
            $ol.append(this.getHomeBreadcrumb("../"));
            var parents = [];
            this.addParentsToBreadcrumbRecursively(parents, data, current.parent);

            parents.sort(function (a, b) {
                return a.displayOrder - b.displayOrder;
            });

            $.each(parents, function (i, item) {
                $ol.append('<li><a href="' + item.url + '">' + item.text + '</a></li>');
            });
        }
        else
            $ol.append(this.getHomeBreadcrumb(""));

        $ol.append('<li class="active"><strong>' + current.text + '</strong></li>');
    },

    getHomeBreadcrumb: function (prefix) {
        return '<li><a href="' + prefix + 'Home.html">Help Home</a></li>';
    },

    addParentsToBreadcrumbRecursively: function (parents, data, parentId) {
        var parent = this.getStoryTopic(data, parentId);
        parents.push(parent);
        if (parent.parent !== "#")
            this.addParentsToBreadcrumbRecursively(parents, data, parent.parent);
    },

    getStories: function (data) {
        var res = [];

        $.each(data, function (i, item) {
            if (item.nodeType === "s")
                res.push(item);
        });


        res.sort(function (a, b) {
            return a.displayOrder - b.displayOrder;
        });

        return res;
    },

    getFavouriteTopics: function (data) {
        var res = [];

        $.each(data, function (i, item) {
            if (item.type === "favourite")
                res.push(item);
        });


        res.sort(function (a, b) {
            return a.displayOrder - b.displayOrder;
        });

        return res;
    },

    displayWarning: function () {
        if (isPublishedToStorage === "false") {
            var alert = '<div class="alert alert-warning alert-dismissible alert-publish" role="alert"><button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button><strong>Warning!</strong> This content is not published to the final publishing location. Avoid sharing the link to this content with users/customers. More information <a href="https://my.guideblocks.com/help/Settings/Draft-vs-Publish.htm?utm_campaign=guideblocks-web" target="_blank">here</a>.</div>';
            $("body").prepend(alert);
            $('.alert-publish').show();
        }
    },

    setLinkUtm: function () {
        var lnk$ = $(".powered-by a");
        if (lnk$ && lnk$.length)
            lnk$.attr("href", "https://guideblocks.com/?utm_source=" + window.location.hostname + "&utm_medium=help-center-page&utm_campaign=help-center");
    },
};

$(function () {
    commonHandler.init();
});